OptionPane

Overview | Package | Class | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.openswing.swing.client
Class OptionPane

    java.lang.Object
      org.openswing.swing.client.OptionPane

public class OptionPane
extends java.lang.Object

Title: OpenSwing Framework

Description: Singleton class that contains a set of static methods for viewing Dialog objects. Based on JOptionPane: this class translates title, text and buttons according to the current internationalization settings.

Copyright: Copyright (C) 2006 Mauro Carniel

This file is part of OpenSwing Framework. This library is free software; you can redistribute it and/or modify it under the terms of the (LGPL) Lesser General Public License as published by the Free Software Foundation; GNU LESSER GENERAL PUBLIC LICENSE Version 2.1, February 1999 This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License for more details. You should have received a copy of the GNU Library General Public License along with this library; if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. The author may be contacted at: maurocarniel@tin.it

Constructor Summary
`OptionPane()`

Method Summary
`static int` | `showConfirmDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType)` Brings up a dialog where the number of choices is determined by the `optionType` parameter.
`static int` | `showConfirmDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType, int messageType)` Brings up a dialog where the number of choices is determined by the `optionType` parameter, where the `messageType` parameter determines the icon to display.
`static int` | `showConfirmDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType, int messageType, java.lang.String imageName)` Brings up a dialog with a specified icon, where the number of choices is determined by the `optionType` parameter.
`static java.lang.String` | `showInputDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType)` Shows a dialog requesting input from the user parented to `parentComponent` with the dialog having the title `title` and message type `messageType`.
`static java.lang.Object` | `showInputDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType, java.lang.String imageName, java.lang.Object[] selectionValues, java.lang.Object initialSelectionValue)` Prompts the user for input in a blocking dialog where the initial selection, possible selections, and all other options can be specified.
`static java.lang.Object` | `showInputDialog2(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType, javax.swing.Icon icon, java.lang.Object[] selectionValues, java.lang.Object initialSelectionValue)`
`static int` | `showInternalConfirmDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType)` Brings up a internal dialog panel where the number of choices is determined by the `optionType` parameter.
`static int` | `showInternalConfirmDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType, int messageType)` Brings up an internal dialog panel where the number of choices is determined by the `optionType` parameter, where the `messageType` parameter determines the icon to display.
`static int` | `showInternalConfirmDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType, int messageType, java.lang.String imageName)` Brings up an internal dialog panel with a specified icon, where the number of choices is determined by the `optionType` parameter.
`static java.lang.String` | `showInternalInputDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType)` Shows an internal dialog requesting input from the user parented to `parentComponent` with the dialog having the title `title` and message type `messageType`.
`static java.lang.Object` | `showInternalInputDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType, java.lang.String imageName, java.lang.Object[] selectionValues, java.lang.Object initialSelectionValue)` Prompts the user for input in a blocking internal dialog where the initial selection, possible selections, and all other options can be specified.
`static void` | `showInternalMessageDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType, java.lang.String imageName)` Brings up an internal dialog panel displaying a message, specifying all parameters.
`static int` | `showInternalOptionDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType, int messageType, java.lang.String imageName, java.lang.Object[] options, java.lang.Object initialValue)` Brings up an internal dialog panel with a specified icon, where the initial choice is determined by the `initialValue` parameter and the number of choices is determined by the `optionType` parameter.
`static void` | `showMessageDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType)` Brings up a dialog that displays a message using a default icon determined by the `messageType` parameter.
`static void` | `showMessageDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int messageType, java.lang.String imageName)` Brings up a dialog displaying a message, specifying all parameters.
`static int` | `showOptionDialog(java.awt.Component parentComponent, java.lang.Object message, java.lang.String title, int optionType, int messageType, java.lang.String imageName, java.lang.Object[] options, java.lang.Object initialValue)` Brings up a dialog with a specified icon, where the initial choice is determined by the `initialValue` parameter and the number of choices is determined by the `optionType` parameter.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### OptionPane

    public OptionPane()

Method Detail

### showConfirmDialog

    public static int showConfirmDialog(java.awt.Component parentComponent,
                                        java.lang.Object message,
                                        java.lang.String title,
                                        int optionType,
                                        int messageType,
                                        java.lang.String imageName)
                                 throws java.awt.HeadlessException

  Brings up a dialog with a specified icon, where the number of choices is determined by the `optionType` parameter. The `messageType` parameter is primarily used to supply a default icon from the look and feel.

  Parameters:
    `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
    `message` - the Object to display (not yet translated)
    `title` - the title string for the dialog (not yet translated)
    `optionType` - an int designating the options available on the dialog: `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION`
    `messageType` - an int designating the kind of message this is, primarily used to determine the icon from the pluggable Look and Feel: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
    `imageName` - name of the file to use as the icon to display in the dialog (it must be stored in "images" subfolder)
  Returns:
    an int indicating the option selected by the user
  Throws:
    `java.awt.HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
  See Also:
    `GraphicsEnvironment.isHeadless()`

### showConfirmDialog

    public static int showConfirmDialog(java.awt.Component parentComponent,
                                        java.lang.Object message,
                                        java.lang.String title,
                                        int optionType,
                                        int messageType)
                                 throws java.awt.HeadlessException

  Brings up a dialog where the number of choices is determined by the `optionType` parameter, where the `messageType` parameter determines the icon to display. The `messageType` parameter is primarily used to supply a default icon from the Look and Feel.

  Parameters:
    `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used.
    `message` - the `Object` to display
    `title` - the title string for the dialog (not yet translated)
    `optionType` - an integer designating the options available on the dialog: `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION`
    `messageType` - an integer designating the kind of message this is; primarily used to determine the icon from the pluggable Look and Feel: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
  Returns:
    an integer indicating the option selected by the user
  Throws:
    `java.awt.HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
  See Also:
    `GraphicsEnvironment.isHeadless()`

### showConfirmDialog

    public static int showConfirmDialog(java.awt.Component parentComponent,
                                        java.lang.Object message,
                                        java.lang.String title,
                                        int optionType)
                                 throws java.awt.HeadlessException

  Brings up a dialog where the number of choices is determined by the `optionType` parameter.

  Parameters:
    `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
    `message` - the `Object` to display
    `title` - the title string for the dialog (not yet translated)
    `optionType` - an int designating the options available on the dialog: `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION`
  Returns:
    an int indicating the option selected by the user
  Throws:
    `java.awt.HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
  See Also:
    `GraphicsEnvironment.isHeadless()`

### showInputDialog

    public static java.lang.Object showInputDialog(java.awt.Component parentComponent,
                                                   java.lang.Object message,
                                                   java.lang.String title,
                                                   int messageType,
                                                   java.lang.String imageName,
                                                   java.lang.Object[] selectionValues,
                                                   java.lang.Object initialSelectionValue)
                                            throws java.awt.HeadlessException

  Prompts the user for input in a blocking dialog where the initial selection, possible selections, and all other options can be specified. The user will able to choose from `selectionValues`, where `null` implies the user can input whatever they wish, usually by means of a `JTextField`. `initialSelectionValue` is the initial value to prompt the user with. It is up to the UI to decide how best to represent the `selectionValues`, but usually a `JComboBox`, `JList`, or `JTextField` will be used.

  Parameters:
    `parentComponent` - the parent `Component` for the dialog
    `message` - the `Object` to display
    `title` - the `String` to display in the dialog title bar
    `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
    `imageName` - name of the file to use as the icon to display in the dialog (it must be stored in "images" subfolder)
    `selectionValues` - an array of `Object`s that gives the possible selections
    `initialSelectionValue` - the value used to initialize the input field
  Returns:
    user's input, or `null` meaning the user canceled the input
  Throws:
    `java.awt.HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
  See Also:
    `GraphicsEnvironment.isHeadless()`

### showInputDialog2

    public static java.lang.Object showInputDialog2(java.awt.Component parentComponent,
                                                    java.lang.Object message,
                                                    java.lang.String title,
                                                    int messageType,
                                                    javax.swing.Icon icon,
                                                    java.lang.Object[] selectionValues,
                                                    java.lang.Object initialSelectionValue)
                                             throws java.awt.HeadlessException

  Throws:
    `java.awt.HeadlessException`

### showInputDialog

    public static java.lang.String showInputDialog(java.awt.Component parentComponent,
                                                   java.lang.Object message,
                                                   java.lang.String title,
                                                   int messageType)
                                            throws java.awt.HeadlessException

  Shows a dialog requesting input from the user parented to `parentComponent` with the dialog having the title `title` and message type `messageType`.

  Parameters:
    `parentComponent` - the parent `Component` for the dialog
    `message` - the `Object` to display
    `title` - the `String` to display in the dialog title bar
    `messageType` - the type of message that is to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
  Throws:
    `java.awt.HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
  See Also:
    `GraphicsEnvironment.isHeadless()`

### showInternalConfirmDialog

    public static int showInternalConfirmDialog(java.awt.Component parentComponent,
                                                java.lang.Object message,
                                                java.lang.String title,
                                                int optionType,
                                                int messageType,
                                                java.lang.String imageName)

  Brings up an internal dialog panel with a specified icon, where the number of choices is determined by the `optionType` parameter. The `messageType` parameter is primarily used to supply a default icon from the look and feel.

  Parameters:
    `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the parentComponent has no Frame, a default `Frame` is used
    `message` - the Object to display (not yet translated) in the dialog; a `Component` object is rendered as a `Component`; a `String` object is rendered as a string; other objects are converted to a `String` using the `toString` method
    `title` - the title string for the dialog (not yet translated)
    `optionType` - an integer designating the options available on the dialog: `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION`messageType` - an integer designating the kind of message this is, primarily used to determine the icon from the pluggable Look and Feel: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE``
    `imageName` - name of the file to use as the icon to display in the dialog (it must be stored in "images" subfolder)
  Returns:
    an integer indicating the option selected by the user

### showInternalConfirmDialog

    public static int showInternalConfirmDialog(java.awt.Component parentComponent,
                                                java.lang.Object message,
                                                java.lang.String title,
                                                int optionType,
                                                int messageType)

  Brings up an internal dialog panel where the number of choices is determined by the `optionType` parameter, where the `messageType` parameter determines the icon to display. The `messageType` parameter is primarily used to supply a default icon from the Look and Feel.

  Parameters:
    `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
    `message` - the Object to display (not yet translated) in the dialog; a `Component` object is rendered as a `Component`; a `String` object is rendered as a string; other objects are converted to a `String` using the `toString` method
    `title` - the title string for the dialog (not yet translated)
    `optionType` - an integer designating the options available on the dialog: `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION`
    `messageType` - an integer designating the kind of message this is, primarily used to determine the icon from the pluggable Look and Feel: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
  Returns:
    an integer indicating the option selected by the user

### showInternalConfirmDialog

    public static int showInternalConfirmDialog(java.awt.Component parentComponent,
                                                java.lang.Object message,
                                                java.lang.String title,
                                                int optionType)

  Brings up a internal dialog panel where the number of choices is determined by the `optionType` parameter.

  Parameters:
    `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
    `message` - the Object to display (not yet translated) in the dialog; a `Component` object is rendered as a `Component`; a `String` object is rendered as a string; other objects are converted to a `String` using the `toString` method
    `title` - the title string for the dialog (not yet translated)
    `optionType` - an integer designating the options available on the dialog: `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION`
  Returns:
    an integer indicating the option selected by the user

### showInternalInputDialog

    public static java.lang.Object showInternalInputDialog(java.awt.Component parentComponent,
                                                           java.lang.Object message,
                                                           java.lang.String title,
                                                           int messageType,
                                                           java.lang.String imageName,
                                                           java.lang.Object[] selectionValues,
                                                           java.lang.Object initialSelectionValue)

  Prompts the user for input in a blocking internal dialog where the initial selection, possible selections, and all other options can be specified. The user will able to choose from `selectionValues`, where `null` implies the user can input whatever they wish, usually by means of a `JTextField`. `initialSelectionValue` is the initial value to prompt the user with. It is up to the UI to decide how best to represent the `selectionValues`, but usually a `JComboBox`, `JList`, or `JTextField` will be used.

  Parameters:
    `parentComponent` - the parent `Component` for the dialog
    `message` - the `Object` to display
    `title` - the `String` to display in the dialog title bar
    `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
    `imageName` - name of the file to use as the icon to display in the dialog (it must be stored in "images" subfolder)
    `selectionValues` - an array of `Objects` that gives the possible selections
    `initialSelectionValue` - the value used to initialize the input field
  Returns:
    user's input, or `null` meaning the user canceled the input

### showInternalInputDialog

    public static java.lang.String showInternalInputDialog(java.awt.Component parentComponent,
                                                           java.lang.Object message,
                                                           java.lang.String title,
                                                           int messageType)

  Shows an internal dialog requesting input from the user parented to `parentComponent` with the dialog having the title `title` and message type `messageType`.

  Parameters:
    `parentComponent` - the parent `Component` for the dialog
    `message` - the `Object` to display
    `title` - the `String` to display in the dialog title bar
    `messageType` - the type of message that is to be displayed: ERROR_MESSAGE, INFORMATION_MESSAGE, WARNING_MESSAGE, QUESTION_MESSAGE, or PLAIN_MESSAGE

### showInternalMessageDialog

    public static void showInternalMessageDialog(java.awt.Component parentComponent,
                                                 java.lang.Object message,
                                                 java.lang.String title,
                                                 int messageType,
                                                 java.lang.String imageName)

  Brings up an internal dialog panel displaying a message, specifying all parameters.

  Parameters:
    `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
    `message` - the `Object` to display
    `title` - the title string for the dialog (not yet translated)
    `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
    `imageName` - name of the file to use as the icon to display in the dialog (it must be stored in "images" subfolder)

### showInternalOptionDialog

    public static int showInternalOptionDialog(java.awt.Component parentComponent,
                                               java.lang.Object message,
                                               java.lang.String title,
                                               int optionType,
                                               int messageType,
                                               java.lang.String imageName,
                                               java.lang.Object[] options,
                                               java.lang.Object initialValue)

  Brings up an internal dialog panel with a specified icon, where the initial choice is determined by the `initialValue` parameter and the number of choices is determined by the `optionType` parameter.

  If `optionType` is `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION` and the `options` parameter is `null`, then the options are supplied by the Look and Feel.

  The `messageType` parameter is primarily used to supply a default icon from the look and feel.

  Parameters:
    `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
    `message` - the object to display in the dialog; a `Component` object is rendered as a `Component`; a `String` object is rendered as a string. Other objects are converted to a `String` using the `toString` method. (not yet translated)
    `title` - the title string for the dialog (not yet translated)
    `optionType` - an integer designating the options available on the dialog: `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION`
    `messageType` - an integer designating the kind of message this is; primarily used to determine the icon from the pluggable Look and Feel: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
    `imageName` - name of the file to use as the icon to display in the dialog (it must be stored in "images" subfolder)
    `options` - an array of objects indicating the possible choices the user can make; if the objects are components, they are rendered properly; non-`String` objects are rendered using their `toString` methods; if this parameter is `null`, the options are determined by the Look and Feel
    `initialValue` - the object that represents the default selection for the dialog; only meaningful if `options` is used; can be `null`
  Returns:
    an integer indicating the option chosen by the user, or `CLOSED_OPTION` if the user closed the Dialog

### showMessageDialog

    public static void showMessageDialog(java.awt.Component parentComponent,
                                         java.lang.Object message,
                                         java.lang.String title,
                                         int messageType,
                                         java.lang.String imageName)
                                  throws java.awt.HeadlessException

  Brings up a dialog displaying a message, specifying all parameters.

  Parameters:
    `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
    `message` - the `Object` to display
    `title` - the title string for the dialog
    `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
    `imageName` - name of the file to use as the icon to display in the dialog (it must be stored in "images" subfolder)
  Throws:
    `java.awt.HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
  See Also:
    `GraphicsEnvironment.isHeadless()`

### showMessageDialog

    public static void showMessageDialog(java.awt.Component parentComponent,
                                         java.lang.Object message,
                                         java.lang.String title,
                                         int messageType)
                                  throws java.awt.HeadlessException

  Brings up a dialog that displays a message using a default icon determined by the `messageType` parameter.

  Parameters:
    `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
    `message` - the `Object` to display
    `title` - the title string for the dialog (not yet translated)
    `messageType` - the type of message to be displayed: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
  Throws:
    `java.awt.HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
  See Also:
    `GraphicsEnvironment.isHeadless()`

### showOptionDialog

    public static int showOptionDialog(java.awt.Component parentComponent,
                                       java.lang.Object message,
                                       java.lang.String title,
                                       int optionType,
                                       int messageType,
                                       java.lang.String imageName,
                                       java.lang.Object[] options,
                                       java.lang.Object initialValue)
                                throws java.awt.HeadlessException

  Brings up a dialog with a specified icon, where the initial choice is determined by the `initialValue` parameter and the number of choices is determined by the `optionType` parameter.

  If `optionType` is `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION` and the `options` parameter is `null`, then the options are supplied by the look and feel.

  The `messageType` parameter is primarily used to supply a default icon from the look and feel.

  Parameters:
    `parentComponent` - determines the `Frame` in which the dialog is displayed; if `null`, or if the `parentComponent` has no `Frame`, a default `Frame` is used
    `message` - the `Object` to display
    `title` - the title string for the dialog (not yet translated)
    `optionType` - an integer designating the options available on the dialog: `YES_NO_OPTION`, or `YES_NO_CANCEL_OPTION`
    `messageType` - an integer designating the kind of message this is, primarily used to determine the icon from the pluggable Look and Feel: `ERROR_MESSAGE`, `INFORMATION_MESSAGE`, `WARNING_MESSAGE`, `QUESTION_MESSAGE`, or `PLAIN_MESSAGE`
    `imageName` - name of the file to use as the icon to display in the dialog (it must be stored in "images" subfolder)
    `options` - an array of objects indicating the possible choices the user can make; if the objects are components, they are rendered properly; non-`String` objects are rendered using their `toString` methods; if this parameter is `null`, the options are determined by the Look and Feel. If options are instanceof String then they will be translated.
    `initialValue` - the object that represents the default selection for the dialog; only meaningful if `options` is used; can be `null`
  Returns:
    an integer indicating the option chosen by the user, or `CLOSED_OPTION` if the user closed the dialog
  Throws:
    `java.awt.HeadlessException` - if `GraphicsEnvironment.isHeadless` returns `true`
  See Also:
    `GraphicsEnvironment.isHeadless()`

Overview | Package | Class | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD